/* TEST PROGRAM 1 FOR 8515 Development Kit

   A simple program for the board first test.
   
   It turns on/off, in sequence, the leds on portc
   and beeps the piezo transducer
   
   hardware needed:  microprocessor,leds, piezo
   
*/

#include <avr\io.h>


void delay(unsigned int p);
void beep(unsigned int t);

int main(void)
{
unsigned char count;
	count=0;

	outp(0xff,DDRC);	//PORT C as output
	outp(0xff,PORTC);	//all pins to 1  (means all leds off)

	outp(0x80,DDRD);	//PORT D input except PD7 output(for buzzer)
	outp(0x7f,PORTD);	//pull-up , PD7 to 0

	beep(4000);		//1 second beep 
	
	delay(200);		//1 second delay 200*5ms

while(1)		//MAIN LOOP forever
	{	
	while(count<8) {		//UP

		outp(0xFF,PORTC);	//turn off leds
		outp(~BV(count),PORTC); //turn on "count" led
		count++;
		beep(1000); 		//delay 250ms
		delay(50); 		//delay 250ms
		}
	count--;	//count=7
	while(count>0) {		//DOWN
		count--;
		outp(0xFF,PORTC);	//turn off leds
		outp(~BV(count),PORTC); //turn on "count" led
		beep(1000);		//delay 250ms
		delay(50);		//delay 250ms
		}
	count++;	//count=1
	}
}



void delay(unsigned int p)   // total delay= p x 5 ms
{
  unsigned int i;
  unsigned char j;
  unsigned char k;
  for(i=0;i<p;i++){			//delay =40000*125ns=5ms
  
    for (j=0;j<100;j++)	{		// (395+1)*100=39600+(4*100)=40000
    	asm("nop");			// 1 cycle
	for (k=0;k<79;k++) asm("nop");	//(4+1)cycles *79= 395
	 }    
	}
}



void beep(unsigned int t)	//buzzer on PD7 ; duration=t*250us (4000=1s)
{
  unsigned int i;
  unsigned char j;
  unsigned char k;

for (i=0;i<t;i++){			//126us*2= 252us period (4KHz)

  sbi(PORTD,7);
    for (j=0;j<2;j++)			//(500+4)*2=1008 *125ns=126us
      for (k=0;k<100;k++) asm("nop");	//(4+1)cycles*100=500
      
  cbi(PORTD,7);
    for (j=0;j<2;j++)			//(500+4)*2=1008 *125ns=126us
      for (k=0;k<100;k++) asm("nop");	//(4+1)cycles*100=500
  }
cbi(PORTD,7);
}






